﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;

namespace flattiverseGameClient
{
    public class LogoutCommand : ICommand
    {
        private MainViewModel _viewModel;

        public LogoutCommand(MainViewModel viewModel)
        {
            _viewModel = viewModel;
        }

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public bool CanExecute(object parameter)
        {
            return _viewModel.IsLoggedIn;
        }

        public void Execute(object parameter)
        {
            _viewModel.LogOut(); //get connector via parameter and check if is connected/logged out?!
        }
    }
}
